;====================================================================
; Test fuer Serielle Schnittstelle 87er Hardware
;
; Stand: 11.12.2021	Hauptschleife Text in Buffer
;
;====================================================================
;
; Belegung 	Monitor Sprungtabellen
; fuer Monitorversionen x.5
;
; Stand:	21.05.2019		Floppyroutinen eingebaut
;		28.01.2018
;
;====================================================================
;
; Monitor				EPROM-Platz #0
;
; Adressen vom Monitor #0
;
rst0		equ	0000h		; RST0	--> Kaltstart
warmst		equ	0003h		;		--> Warmstart
fquarz		equ  	0006h		; Taktfrequenz in MHz
timprl		equ  	0007h		; Prellzeit der Tastatur
rst1  		equ 	0008h		; RST1
dely1		equ 	000bh		; DELY1 --> 1ms Laufzeit
prtbdr		equ  	000eh		; Baudrate fuer Drucker	= 4800Bd
rst2		equ 	0010h		; RST2
dely100 	equ 	0013h		; DELY100 --> mit SSG-Anzeige
casbdr		equ  	0016h		; Baudrate fuer Cassetten = 1200Bd
rst3		equ 	0018h		; RST3
onesec 		equ 	001bh		; ONESEC --> 1s Laufzeit
v24bdr		equ  	001eh		; Baudrate fuer V24-Schnittstelle = 4800Bd
rst4		equ 	0020h		; RST4
trap		equ	0024h		; TRAP	--> FDC-Routinen
rst5		equ 	0028h		; RST5
rst55		equ 	002ch		; RST5.5 --> FDC-Routinen
rst6		equ 	0030h		; RST6
rst65		equ 	0034h		; RST6.5
rst7		equ 	0038h		; RST7
rst75		equ 	003ch		; RST7.5
mvers		equ  	003fh		; Monitorversion z.B. 55 fuer Version 5.5
adrset		equ 	0040h		; Adresse laden
ci		equ 	0043h		; CI ASCII-Tastatur abfragen (A)
ri		equ 	0046h		; RI ein Byte von Kasetteninterface empfangen (A)
co		equ 	0049h		; CO Inhalt(C) ASCII an Bildschirm (UPDATE)
po		equ 	004ch		; PO Inalt (C) auf Kasetteninterface (1200Bd)
lo		equ 	004fh		; LO Inalt (C) ASCII-Zeichen V24 (4800Bd)
csts  		equ 	0052h		; CSTS Status ASCII-Tastatur
						;	 gedrueckt Z=0 sonst Z=1
csinit		equ 	0055h		;
loinit		equ 	0058h		; LO-Init
maxram		equ 	005bh		; MEMCHK Speichertest (AB)max Adressen
prtmod		equ  	005eh		; Betriebsart
;						; (8bit,1Stop,ohne Paritaet, Takt/16) =15h
casmod		equ  	005fh		; Cassettenbetriebsart
						; (8daten, ohne Paritaet) = 10h
v24mod		equ  	0060h		; V24 Betriebsart
						; (8bit,1Stop,ohne Paritaet, Takt/16) = 15h
time		equ 	0061h		; TI Uhrzeit lesen ASCII in Buffer
v24ini		.dw  	0064h		; wird ueber PCHL aus Videomonitor angesprungen
cnvbyt 		equ 	0067h		; SSG-Umsetzen
reles		equ 	006ah		; HEX-Tastatur auf Loslassen warten
press  		equ 	006dh		;  "           auf Drücken warten
hhkey		equ 	0070h		; HEX-Input
cckey  		equ 	0073h		; CMD-Input
datset 		equ 	0076h		; Daten-Mode einstellen
writur		equ 	0079h		; WRITUR Uhrzeit stellen
					; (HL)Std,min, (BC)Wochentag, (DE)Monat,Jahr
readur		equ 	007ch		; READUR Uhrzeit lesen BCD(HL)Adresse
save   		equ 	007fh		; Register vorbereiten/sichern
restor		equ 	0082h		; Registersatz laden, Start
fill		equ 	0058h		; FILL Speicher fuellen (SRCBEG,SRCEND,DSTBEG)
copy 		equ 	0088h		; COPY Speicher kopieren (SRCBEG,SRCEND,DSTBEG)
casot		equ 	008bh		; Casetten Ausgabe
casin		equ 	008eh		; Eingabe
exchan		equ 	0091h		; Copy mit Adressumsetzung
ezudsp		equ 	0094h		; Uhr in SSG-Anzeige
dspacc		equ 	0097h		; (ACC) darstellen
dsphl		equ 	009ah		; (HL) darstellen
dsperr 		equ 	009dh		; Fehleranzeige
;
; Anmerkung
; RST Sprungverteiler ist in der Datei System-ram.asm abgebildet
; lediglich der trap springt aus Timinggründen direkt über PCHL
; in die FDC-Routine
;
;====================================================================
;
; Video-Monitor			Eprom-Platz #1
;
kalt:		equ	1000h		; Kaltstart
warm:		equ	1003h		; Warmstart
;co:		equ	1006h		; Console Output
;ci:		equ	1009h		; Console Input
;csts:		equ	100Ch		; Console Status
break:		equ	100Fh		; Programmabbruch?
parin:		equ	1012h		; Parameter einlesen
hxtest:		equ	1015h		; ASCII/HEX-Umsetzung
compar:		equ	1018h		; MEM-Differenz
sample:		equ	101Bh		; Zeichenvorrat ausgeben
v24ot: 		equ	101Eh		; PO über V.24
string:		equ	1021h		; Video-Ausgabe
v24in: 		equ	1024h		; RI über V.24
error:		equ	1027h		; Fehlermeldung
undrln:		equ	102Ah		; String invers
clrvid:		equ	102Dh		; Clear Video-RAM;
clrlin:		equ	1030h		; Bildzeile löschenassembler
crspos:		equ	1033h		; Cursor positionieren;
crson: 		equ	1036h		; Cursor einschalten;
crsoff:		equ	1039h		; Cursor ausschaltendisass
adrot: 		equ	103Ch		; (H&L) ausgeben;
bytot: 		equ	103Fh		; (ACC) ausgeben; Editor
bytbin:		equ	1042h		; (ACC) binaer ausgeben;
regsot:		equ	1045h		; (Regs) ausgebenedit
;
;====================================================================
;
; 87er V24-Schnittstellenkarte
;
uart_c		equ	0e9h		; ACIA 6850 Control/Statusregister
uart_d		equ  	0f9h		;           Daten lesen/schreiben
;
cs_mode		equ  	0a9h		; Modus (Eingangswahlschalter)
cs_bell		equ  	0b9h		; Bell  (Schnarre)
;
timer_c		equ  	0d9h		; Timer 8253 Controlregister
timer_0		equ  	89h		;            Zaehler 0
timer_1		equ  	99h		;	   Zaehler 1 * nicht benutzt
timer_2		equ  	0c9h		;	   Zaehler 2 * nicht benutzt
;
;
;====================================================================
;
;
regb:		equ	2900h		; Zaehler
buff:		equ	9000h		; Textbuffer
stack:		equ	0ffffh		; Userstack

		org	8000h		; Programm


start:		lxi	sp,stack	;
		call	inibd		; Baudrate einstellen
		lxi	h,msg0		; Begruessung
		call	string		;
		lxi	h,buff		;
		mvi	b,0ffh		;

loop1:		call	csts		;
		jz	loop1		;
		call	ci		;
		cpi	20h		; Leertaste -> Ende
		jz	ende		;
		ani	7fh		;
		mov	c,a		;
loop2:		call	csts		;
		jnz	loop2		;
		mov	m,c		;
		call	co		;
		inx	h
		dcr	b		;
		jz	ende		;
		call	mv24tx		;
		call	dely1		;






		jmp	loop1











ende:		mov	a,b		; Zaehler sichern
		sta	regb		;
		lxi	h,msge		; Ende
		call	string		;
		call	onesec
		jmp	warm		; zum Videomonitor




msg0:		db	" TX Test 87er"
		db	0dh		; CR
		db	0ah		; LF
		db	0h		; Ende String



msge:		db	0dh		; CR
		db	0ah		; LF
		db	" ENDE "
		db	0h		; Ende String




;====================================================================
; V24 Moppel 87er Hardware
; Routinen aus BIOS
;
; Baudratentabelle fuer
; CPU-Frequenz 6,144MHz
;
; Teilfaktor fuer Timer
;	= CPU-Frequenz /2 = Systemtakt / 4800bd / 16 = 40
;                                                 I
;                                                 UART Teiler
;
; Wert als BCD, da Timer auf BCD Zaehler eingestellt wird
;               sonst Umrechnung nach Binaer notwendig
;
; 19200BD = 10 lowByte
;  9600Bd = 20 .
;  4800Bd = 40 .
;  2400Bd = 80 .
;  1200Bd = 60 lowByte
;	    01 highByte
;
; (DE) Baudrate laden
;
inibd:		lxi	d,0020h		; Startwert 9600Bd
;
; Baudrate laden (DE)
;
mv24bd:		mvi	a,37h		; Ctl Zaehler als BCD-Zaehler
		out	timer_c		;
		mov	a,e		;
		out 	timer_0		; Zaehler untere haelfte
		mov	a,d		;
		out 	timer_0		; Zaehler obere haelfte
		mvi 	a,48h		; v24 modus
		out 	cs_mode		;
		mvi 	a,03		; Reset UART
		out 	uart_c		;
		ret
;
; V24 Input-Status	(A)=00h kein Zeichen
;				(A)=FFh Zeichen vorhanden
;
mv24ist:	mvi 	a,15h		;
		out 	uart_c		; clk/16,8bit,1stop,ohne paritaet , RTS off
mvist_l:	in 	uart_c		; Warten bis Empfangsregister voll
		ani 	01h		;
		jnz 	mvist_e		; Zeichen vorhanden
		mvi 	a,55h		; RTS on
		out 	uart_c		;
		xra 	a		;
		ret			;

mvist_e:	mvi 	a,55h		; RTS on
		out 	uart_c		;
		mvi 	a,0ffh		;
		ret			;
;
; Byte von V24 empfangen (A)
; wartet bis Zeichen vorhanden ist
;
mv24rx:		mvi 	a,15h		;
		out 	uart_c		; clk/16,8bit,1stop,ohne paritaet , RTS off
mvrx_l:		in 	uart_c		; Warten bis Empfangsregister voll
		ani 	01h		;
		jz  	mvrx_l		; warten
		mvi 	a,55h		; RTS on
		out 	uart_c		;
		in 	uart_d		; Daten auslesen
		ret			;
;
; Byte v24 senden (C)
; wartet bis Empfaenger bereit ist
;
mv24tx:		mvi 	a,55h		;
		out 	uart_c		; clk/16,8bit,1stop,ohne paritaet , RTS on
mvtx_l:		in 	uart_c		; Warten bis Senderegister leer
		ani 	02h		;
		jz	mvtx_l		;
		mov	a,c			;
		out 	uart_d		; Daten senden
		ret			;
;
; Byte V24 empfangen (A)
; mit Zeitueberwachung 10s (A)=1ah Control Z
;
mv24rxz:	push 	b		; ein Byte ueber V24 empfangen (A)
		lxi 	b,10000		; max Wartezeit 10s
		mvi 	a,15h		;
		out 	uart_c		; clk/16,8bit,1stop,ohne paritaet , RTS off
mvrxz_l:	in 	uart_c		; Warten bis Empfangsregister voll
		ani 	01h		;
		jnz  	mvrxz_e		;
		call 	dely1		; 1ms warten
		dcr	c		;
		jnz 	mvrxz_l		;
		dcr	b		;
		jnz	mvrxz_l		;
		pop 	b		;
		mvi	a,55h		; RTS on
		out	uart_c		;
		mvi 	a,1ah		; SUB (Control-Z)
		ret

mvrxz_e:	mvi	a,55h		; RTS on
		out	uart_c		;
		in	uart_d		; Daten auslesen
		pop	b		;
		ret			;
;
; Byte V24 senden (C)
; mit Zeitueberwachung
;
mv24txz:	mvi 	a,55h		; ein Byte ueber V24 senden (C)
		out 	uart_c		; clk/16,8bit,2stop,ohne paritaet RTS on
		mvi 	b,10		; max Wartezeit 10ms
mvtxz_l:	in 	uart_c		; Warten bis Senderegister leer
		ani 	02h		;
		jnz  	mvtxz_o		;
		call 	dely1		;
		dcr 	b		;
		jnz 	mvtxz_l		;
		mvi 	a,04h		; Zeituebschreitung (End of Transmission)
		ret			;
	;
mvtxz_o:	mov 	a,c		; Daten ausgeben
		out 	uart_d	;
		ret			;
;
;
;-----------------------------------------------------------------------------
end